/*
 * Proyecto: DbfTest
 * Fichero: Form1.prg
 * Descripcin:
 * Autor:
 * Fecha: 19/05/2004
 */

#include "Xailer.ch"
#include "report.ch"

CLASS TForm1 FROM TForm

   COMPONENT oStatusBar1
   COMPONENT oBrw
   COMPONENT oReBar1
   COMPONENT oSharedModule1 AS TSharedModule1

   PROPERTY nTag INIT 1 WRITE INLINE ::SetTag( Value )

   DATA oToolBar, oRebarBand, oTagMenu, oTagBtn, oFilterBtn, oEdiBusqueda
   DATA aTags

   METHOD CreateForm()
   METHOD FormInitialize( oSender )
   METHOD SetTag( Value )
   METHOD Filter()
   METHOD AddNew()
   METHOD Edit()
   METHOD Delete()
   METHOD Report()
   METHOD BrwSeek( oSender, cSeek )
   METHOD BrwChange( oSender, lBookMarkChanged )

ENDCLASS

#include "Form1.xfm"

//------------------------------------------------------------------------------

METHOD FormInitialize( oSender ) CLASS TForm1

   LOCAL oSortMenu
   LOCAL aTags
   LOCAL nFor

   set date italian

   MENU ::oMenu
      MENUITEM "&File"
      MENU
         MENUITEM "&Append"
         MENUITEM "&Edit"
         MENUITEM "&Delete"
         SEPARATOR
         MENUITEM "&Printer configuration" ACTION Printer:Setup( Self )
         SEPARATOR
         MENUITEM "&Exit" ACTION ::Close()
      ENDMENU
      MENUITEM "&Help"
      MENU
         MENUITEM "About..." ;
                  ACTION ShellAbout( Application:Handle, Application:cTitle, ;
                                     "Copyright Xailer 2003-2004" )
      ENDMENU
   ENDMENU

   oSortMenu := TMenu():Create( Self, .t. )

   ::aTags := ::oSharedModule1:oSharedDataset:GetTags()
   ::oSharedModule1:oSharedDataset:OrdSetFocus("")

   FOR nFor := 1 to len( ::aTags )
      WITH OBJECT TMenuItem():New( oSortMenu )
         :cText := "Order by " + ::aTags[ nFor ]
         :Cargo := nFor
         :OnClick  := {|o| ::nTag := o:Cargo }
         :Create()
      END
   NEXT

   WITH OBJECT ::oToolBar := TToolBar():New( ::oRebar1 )
      :lList     := .t.
      :lAutoSize := .t.
      :Create()
      ::oTagBtn := :AddButton( "", "BMP_SORT",,, "Set Order", {|| ::nTag++ }, oSortMenu )
      ::nTag := 1
      WITH OBJECT ::oFilterBtn := :AddButton( "", "BMP_FILTER",,, "Set Filter", {|| ::Filter() } )
         :lChecked := .f.
      END
      :AddSeparator()
      :AddButton( "", "BMP_FIRST",,, "First record", {|| ::oBrw:GoTop() } )
      :AddButton( "", "BMP_PREVIOUS",,, "Previous record", {|| ::oBrw:GoUp() } )
      :AddButton( "", "BMP_NEXT",,, "Next record ", {|| ::oBrw:GoDown() } )
      :AddButton( "", "BMP_LAST",,, "Last record", {|| ::oBrw:GoBottom() } )
      :AddSeparator()
      :AddButton( "", "BMP_APPEND",,, "Append", {|| ::AddNew() } )
      :AddButton( "", "BMP_EDIT",,, "Edit", {|| ::Edit() } )
      :AddButton( "", "BMP_DELETE",,, "Delete", {|| ::Delete() } )
      :AddSeparator()
      :AddButton( "", "XA_BMP_PRINTER",,, "Print", {|| ::Report() } )
      :AddButton( "", "XA_BMP_EXIT",,, "Exit", {|| ::Close() } )
   END

   WITH OBJECT ::oRebarBand := TRebarBand():New( ::oRebar1 )
      :oControl := ::oToolBar
      :Create()
   END

   WITH OBJECT ::oEdiBusqueda := TEditBtn():New( ::oRebar1 )
      :oBitmap    := "lupa16"
      :OnBtnClick := {|o| ::oBrw:Seek( o:Value ), nil }
      :nMaxLength := 100
      :Create()
      ::oBrw:oSeek := ::oEdiBusqueda
   END

   WITH OBJECT TRebarBand():New( ::oRebar1 )
      :cText := "Bsqueda:"
      :oControl := ::oEdiBusqueda
      :Create()
   END

RETURN Nil

//------------------------------------------------------------------------------

METHOD SetTag( nTag ) CLASS TForm1

   if nTag > len( ::aTags )
      nTag := 1
   endif

   ::FnTag := nTag

   if ::oSharedModule1:oSharedDataset != nil
      ::oSharedModule1:oSharedDataset:OrdSetFocus( nTag )
   endif

   if ::oBrw != nil
      ::oBrw:Refresh( .t. )
   endif

   if ::oTagBtn != nil
      ::oTagBtn:cText := "Order by " + ::aTags[ nTag ]
   endif

RETURN nil

//------------------------------------------------------------------------------

METHOD Filter() CLASS TForm1

   local lFilterBar

   WITH OBJECT ::oFilterBtn
      lFilterBar   := !:lChecked
      :lChecked := lFilterBar
   END

   WITH OBJECT ::oBrw
      :lFilterBar := !:lFilterBar
   END

RETURN NIL

//------------------------------------------------------------------------------

METHOD AddNew() CLASS TForm1

   LOCAL oFrm

   WITH OBJECT oFrm := TForm2():New( Self )
      :cText := "Customer Append"
      ::oSharedModule1:oSharedDataset:AddNew()
      :ShowModal()
      if :nModalResult == mrOK
         ::oSharedModule1:oSharedDataset:Update()
         ::oBrw:Refresh()
      else
         ::oSharedModule1:oSharedDataset:Cancel()
      endif
   END WITH

RETURN NIL

//------------------------------------------------------------------------------

METHOD Edit() CLASS TForm1

   LOCAL oFrm

   WITH OBJECT oFrm := TForm2():New( Self )
      :cText := "Customer Edit"
      ::oSharedModule1:oSharedDataset:Edit()
      :ShowModal()
      // Since the form is closed here is important that you put lHideOnClose to .T.
      // when finished just destroy the form with End()
      if :nModalResult == mrOK
         ::oSharedModule1:oSharedDataset:Update()
         ::oBrw:RefreshCurrent()
      else
         ::oSharedModule1:oSharedDataset:Cancel()
      endif
      :End()
   END WITH

RETURN NIL

//------------------------------------------------------------------------------

METHOD Delete() CLASS TForm1

   if MsgYesNo( "Delete actual Record?" )
      ::oSharedModule1:oSharedDataset:Delete()
   endif

RETURN NIL

//------------------------------------------------------------------------------

METHOD Report() CLASS TForm1

   local oReport

   REPORT oReport TITLE "Table Customer" PREVIEW

   COLUMN OF oReport ;
      TITLE "Name" ;
      DATA ::oSharedModule1:oSharedDataset:Name // This is a calculated field

   COLUMN OF oReport ;
      TITLE "Street" ;
      DATA ::oSharedModule1:oSharedDataset:Street

   COLUMN OF oReport ;
      TITLE "City" ;
      DATA ::oSharedModule1:oSharedDataset:City

   ::oSharedModule1:oSharedDataset:SaveState( .T. )
   ::oSharedModule1:oSharedDataset:Gotop()

   RUN REPORT oReport

   ::oSharedModule1:oSharedDataset:RestoreState( .T. )

RETURN NIL

//------------------------------------------------------------------------------

METHOD BrwSeek( oSender, cSeek ) CLASS TForm1

RETURN ::oSharedModule1:oSharedDataset:Seek( Upper( cSeek ) )

//------------------------------------------------------------------------------

METHOD BrwChange( oSender, lBookMarkChanged ) CLASS TForm1

   ::oStatusBar1:aItems[1]:cText := "Record: " + AllTrim( Str( ::oBrw:nKeyNo ) )

RETURN Nil

//------------------------------------------------------------------------------
